// File HOPSYS.CPP Hopfield Associative Memory System with
//               Turbo Vision interface

#include "hopsetup.cpp"

hop_setup_rec g_hop_rec;

void handle_system (system_response *control_flag)
  {
   thopsetapp *Setup_App = new thopsetapp();
   quit_flag = quit;
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   }

int main()
   {
   system_response prog_control = startup;
   initialize_hop_setup (&g_hop_rec,&g_pattern_data);
   strcpy (system_name,"Hopfield Assoc. Memory Network");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case run_net:
      run_hopfield_network (&g_hop_rec,&g_pattern_data);
      break;
   case train_net:
      train_hopfield_network (&g_hop_rec,&g_pattern_data);
      break;
   case edit_data:
      edit_xmp_data_file (&g_hop_rec,&g_pattern_data);
      break;
   case special:
      print_inner_products (&g_hop_rec,&g_pattern_data);
      break;
   }
   } while (prog_control != quit);
   return 0;
   } // end main