/*  File CG.H  Conjugate Gradient header file  */

#ifndef CG_H
#define CG_H

#include "uttypes.h"

/*  CGPROCS.C  */

short conjugate_gradient (float (*obj_fn)(d_vector w),
     void (*gradient_of_obj_fn)(d_vector w,d_vector grad),
     d_vector weights,int no_of_wts,float error_tol,float *obj_value);

#endif